module MainExercices where

import Prelude

import DOM.Simple (Element, boundingRect)
import DOM.Simple as DOM
import DOM.Simple.Console (log)
import DOM.Simple.Document (document)
import DOM.Simple.Element (boundingRect)
import DOM.Simple.Types (DOMRect)
import Data.Maybe (Maybe(..))
import Data.Nullable (toMaybe, null)
import Effect (Effect)
import Effect.Class (liftEffect)
import FFI.Simple ((...), delay, args2)
import Phylo.Ressources as PR
import Phylo.Types as PT
import Phylo.TypesExample as PTE
import Reactix as R
import Reactix.DOM.HTML as H

main :: Effect Unit
main = paint $ toMaybe (document ... "getElementById" $ [ "app" ])

render :: R.Element -> DOM.Element -> Effect Unit
render e d = delay unit $ \_ -> pure $ R.reactDOM ... "render" $ args2 e d

paint :: Maybe Element -> Effect Unit
paint Nothing = log "[main] container not found"
paint (Just c) = render (app {} []) c

app :: {} -> Array R.Element -> R.Element
app = R.createElement appCpt

appCpt :: R.Component()
appCpt = R.hooksComponentWithModule "Phylo.Ressources" "app" cpt where
  cpt {} _ = do
    R.useEffect' $ do
      PTE.logPhyloJSON
      delay unit $ \_ -> do
        -- PR.drawIsoline
        pure unit
    pure $ H.div {className:"Mèmiscape"}[
      H.div{className:"PhyloCorpus"}[H.text "Corpus",
        H.div{className:"PhyloCorpusInfo"}[H.span{id:"docs"}[H.text "docs"] -- Insert value JSON
                                          ,H.span{id:"foundations"}[H.text "foundations"]
                                          ,H.span{id:"periods"}[H.text "periods"]] 
      ],
      H.div{className:"PhyloInfo"}[H.text "Phylomemy",
        H.div{className:"PhyloInfoCount"}[H.span{id:"phyloTerms"}[H.text ("terms")]
                                        ,H.span{id:"phyloGroups"}[]
                                        ,H.span{id:"phyloBranches"}[H.text ("branches")]]
      ],
      H.div{id:"Isoline"}[H.text "Here is Isoline"]
    ]

      
      